#include <bits/stdc++.h>
#define int long long
using namespace std;
string inslo[105], slo[105];
int pocz[105], block[105];
int mac[105][105];
bool srt(string &a, string &b)
{
	return a.size() < b.size();
}
const int N = 103, mod = 1000000007;
struct macierz
{
	int t[105][105];
	macierz() {
		for (int i=0; i<N; i++)
			for (int j=0; j<N; j++)
				t[i][j]=0;
	}
};
macierz mnoz(macierz &a, macierz &b)
{
	macierz res;
	for (int i=0; i<N; i++)
	{
		for (int j=0; j<N; j++)
		{
			for (int h=0; h<N; h++)
			{
				res.t[i][j] += a.t[i][h] * b.t[h][j];
				res.t[i][j] %= mod;
			}
		}
	}
	return res;
}
macierz neutral()
{
	macierz res;
	for (int i=0; i<N; i++)
		res.t[i][i]=1;
	return res;
}
macierz normal()
{
	macierz res;
	for (int i=0; i<N; i++)
	{
		for (int j=0; j<N; j++)
		{
			res.t[i][j]=mac[i][j];
		}
	}
	return res;
}
macierz pot(macierz &a, int b) //&
{
	if (b == 0)
		return neutral();
	macierz res2 = pot(a, b/2);
	macierz res3 = mnoz(res2, res2);
	macierz res;
	if (b%2==1)
		res = mnoz(res3, a);
	else
		res = res3;
	return res;
}
bool contains(string &a, string &b)
{
	for (int i=0; i<(int)b.size(); i++)
	{
		int ok = 1;
		for (int j=0; j<(int)a.size(); j++)
		{
			if (j+i >= (int)b.size() || a[j] != b[j+i])
			{
				ok=0;
				break;
			}
		}
		if (ok == 1)
			return true;
	}
	return false;
}
bool isPref(string &a, string &b, int pr)
{
	if (pr > (int)b.size())
		return false;
	for (int i=0; i<pr; i++)
	{
		if (a[i] != b[b.size()-pr+i])
			return false;
	}
	return true;
}
int32_t main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, q;
	cin >> n >> q;
	slo[0] = "ba";
	for (int i=1; i<=q; i++)
	{
		int l;
		cin >> l;
		//pocz[i] = pocz[i-1] + slo[i-1].size();
		cin >> inslo[i];
	}
	sort(inslo+1, inslo+q+1, srt);
	for (int i=1; i<=q; i++)
	{
		for (int j=i+1; j<=q; j++)
		{
			if (contains(inslo[i], inslo[j]))
				block[j] = 1;
		}
	}
	int akt=1;
	for (int i=1; i<=q; i++)
	{
		if (block[i] == 1)
			continue;
		slo[akt] = inslo[i];
		akt++;
	}
	q = akt-1;
	mac[0][0]=26;
	for (int i=1; i<=q; i++)
	{
		//cout << slo[i] << "\n";
		pocz[i] = pocz[i-1] + slo[i-1].size() - 1;
		if (slo[i].size() == 1)
		{
			mac[0][0]--;
			continue;
		}
		//cout << pocz[i] << "\n";
		mac[0][pocz[i]]=1;
		mac[pocz[i]+slo[i].size()-2][0] = -1;
	}
	// porownujemy prefikso sufiksy
	for (int i=1; i<=q; i++)
	{
		for (int j=1; j<=q; j++)
		{
			for (int pr=1; pr<(int)slo[i].size(); pr++)
			{
				if (pr!=1)
					mac[pocz[i]+pr-2][pocz[i]+pr-1]=1;
				if (isPref(slo[i], slo[j], pr))
				{
					mac[pocz[j] + slo[j].size() - 2][pocz[i] + pr - 1] = -1; // ???
				}
			}
		}
	}
	/*for (int i=0; i<6; i++)
	{
		for (int j=0; j<6; j++)
			cout << normal().t[i][j] << " ";
		cout << "\n";
	}*/
	macierz norm = normal();
	cout << (mod+pot(norm, n).t[0][0])%mod << "\n";
}

